﻿using System;
using System.Globalization;
using Xamarin.Forms;

namespace Borepin.Converter
{
    public class MachineStateStringConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture)
        {
            switch((FabAccessAPI.Schema.Machine.MachineState)value)
            {
                case (FabAccessAPI.Schema.Machine.MachineState.free):
                    return "Free";
                case (FabAccessAPI.Schema.Machine.MachineState.inUse):
                    return "In Use";
                case (FabAccessAPI.Schema.Machine.MachineState.toCheck):
                    return "To Check";
                case (FabAccessAPI.Schema.Machine.MachineState.reserved):
                    return "Reserved";
                case (FabAccessAPI.Schema.Machine.MachineState.blocked):
                    return "Blocked";
                case (FabAccessAPI.Schema.Machine.MachineState.disabled):
                    return "Disabled";
                default:
                    return "Unknown";
            }
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture)
        {
            throw new NotSupportedException();
        }
    }
}
