﻿using Borepin.Base;
using Borepin.Model;
using Prism.Navigation;
using System.Threading.Tasks;
using System.Windows.Input;
using Xamarin.Forms;

namespace Borepin.PageModel.AddServerProcess
{
    public class ChooseAuthTypePageModel : PageModelBase
    {
        #region Private Fields
        private Connection _Connection;
        #endregion

        #region Contructors
        public ChooseAuthTypePageModel(INavigationService navigationService) : base(navigationService)
        {
            AuthPlainCommand = new Command(AuthPlainCommandExecute);
        }
        #endregion

        #region LoadData
        public override Task LoadData()
        {
            IsBusy = false;

            return Task.CompletedTask;
        }
        #endregion

        #region Commands
        private ICommand _AuthPlainCommand;
        public ICommand AuthPlainCommand
        {
            get => _AuthPlainCommand;
            set => SetProperty(ref _AuthPlainCommand, value);
        }
        public async void AuthPlainCommandExecute()
        {
            _Connection.AuthenticationTyp = AuthenticationTyp.PLAIN;

            INavigationParameters parameters = new NavigationParameters()
            {
                {"instance", _Connection },
            };

            await _NavigationService.NavigateAsync("AddServerProcess_AuthPlainPage", parameters).ConfigureAwait(false);
        }
        #endregion

        #region INavigationAware
        public override void OnNavigatedTo(INavigationParameters parameters)
        {
            if (parameters.ContainsKey("instance") && parameters["instance"] is Connection)
            {
                _Connection = parameters["instance"] as Connection;
            }
            else
            {
                _Connection = new Connection();
            }

            LoadData();
        }

        public override void OnNavigatedFrom(INavigationParameters parameters)
        {
            if (parameters.GetNavigationMode() == NavigationMode.Back)
            {
                parameters.Add("instance", _Connection);
            }
        }
        #endregion
    }
}
