﻿using Borepin.Base;
using Borepin.Model;
using Borepin.Service.BFFH;
using Prism.AppModel;
using Prism.Navigation;
using System.Collections.Generic;
using System.Threading.Tasks;

namespace Borepin.PageModel
{
    public class StartPageModel : PageModelBase, IPageLifecycleAware, IInitialize
    {
        #region Private Fields
        private readonly IBFFHService _BFFHService;
        #endregion

        #region Constructors
        public StartPageModel(INavigationService navigationService, IBFFHService bffhService) : base(navigationService)
        {
            _BFFHService = bffhService;
        }
        #endregion

        #region LoadData
        public override Task LoadData()
        {
            return Task.CompletedTask;
        }
        #endregion

        #region IInitialize
        public void Initialize(INavigationParameters parameters)
        {
            
        }
        #endregion

        #region IPageLifecycleAware
        public async void OnAppearing()
        {
            IList<Connection> connection_list = await _BFFHService.GetConnections().ConfigureAwait(false);
            if (connection_list.Count == 0)
            {
                await _NavigationService.NavigateAsync("/MainPage/NavigationPage/SetUpProcess_WelcomePage").ConfigureAwait(false);
            }
            else
            {
               await _NavigationService.NavigateAsync("/MainPage/NavigationPage/ServerListPage").ConfigureAwait(false);
            }
        }

        public void OnDisappearing()
        {
            
        }
        #endregion

        #region INavigationAware
        public override void OnNavigatedFrom(INavigationParameters parameters)
        {
            
        }

        public override void OnNavigatedTo(INavigationParameters parameters)
        {
            
        }
        #endregion
    }
}
