﻿using Prism.Mvvm;
using FabAccessAPI.Schema;

namespace Borepin.ViewModel
{
    public class MachineListItemViewModel : BindableBase
    {
        public MachineListItemViewModel(Machine instance)
        {
            _Instance = instance;

            Name = instance.Name;
            State = instance.State;
        }

        private Machine _Instance;
        public Machine Instance
        {
            get => _Instance;
            set => SetProperty(ref _Instance, value);
        }

        private string _Name;
        public string Name
        {
            get => _Name;
            set => SetProperty(ref _Name, value);
        }

        private Machine.MachineState _State;
        public Machine.MachineState State
        {
            get => _State;
            set => SetProperty(ref _State, value);
        }

        private bool _IsUserAssigned = false;
        public bool IsUserAssigned
        {
            get => _IsUserAssigned;
            set => SetProperty(ref _IsUserAssigned, value);
        }
    }
}
