﻿using System;
using System.Threading.Tasks;
using NUnit.Framework;
using Borepin.Service.Storage;
using NSubstitute;
using Borepin.Service.BFFH;
using Borepin.Model;

namespace Borepin_Test
{
    public class BFFHService_Test
    {
        [Test, Explicit] 
        public async Task Connect()
        {
            IPreferenceStorageService preferenceStorageService = Substitute.For<IPreferenceStorageService>();
            ISecretStorageService secretStorageService = Substitute.For<ISecretStorageService>();

            IBFFHService bffhService = new BFFHService(preferenceStorageService, secretStorageService);

            Connection connection = new Connection()
            {
                Address = new Uri("fabaccess://127.0.0.1:59661"),
                Username = "Testuser"
            };

            await bffhService.Connect(connection, "secret");
        }
    }
}
